package com.bergerkiller.bukkit.nolagg.bufferedtag;

import java.io.DataInputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.Map;

import net.minecraft.server.NBTBase;
import net.minecraft.server.NBTTagCompound;

@SuppressWarnings({"rawtypes", "unchecked"})
public class NBTTagCompoundBuffered extends NBTTagCompound {

	private static Field mapfield;
	
	public static NBTTagCompoundBuffered readFrom(String name, final Map<String, byte[]> buffers, DataInputStream stream) throws IOException {
		try {
			if (mapfield == null) {
				mapfield = NBTTagCompound.class.getDeclaredField("map");
				mapfield.setAccessible(true);
			}
			NBTTagCompoundBuffered rval = new NBTTagCompoundBuffered(name);
			Map map = (Map) mapfield.get(rval);
			NBTBase nbtbase;
			while ((nbtbase = NBTBaseBuffered.readFrom(buffers, stream)).getTypeId() != 0) {
				map.put(nbtbase.getName(), nbtbase);
			}
			return rval;
		} catch (Throwable t) {
			t.printStackTrace();
			return null;
		}
	}
	
	private NBTTagCompoundBuffered(String name) {
		super(name);
	}
	
}
