package com.bergerkiller.bukkit.nolagg.sending;

import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.Map;
import java.util.logging.Level;

import com.bergerkiller.bukkit.nolagg.NoLagg;
import com.bergerkiller.bukkit.nolagg.datapool.Pool;
import com.bergerkiller.bukkit.nolagg.datapool.PoolBuffer;
import com.bergerkiller.bukkit.nolagg.datapool.PoolData;

import net.minecraft.server.EntityPlayer;
import net.minecraft.server.Packet;
import net.minecraft.server.Packet51MapChunk;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class BufferedPacket51MapChunk extends Packet51MapChunk implements PoolData<byte[]> {
	
	public static String getBufferSizeName() {
		int size = 80 * pool.size();
		if (size < 1000) {
			return size + " kb";
		} else {
			return ((double) size / 1000) + " mb";
		}
	}
	private static Pool<byte[]> pool = new Pool<byte[]>(21);
		
	@Override
	public byte[] getNewData() {
		return new byte[81920];
	}
	
	private EntityPlayer ep = null;
	private PoolBuffer<byte[]> buffer;
	public BufferedPacket51MapChunk(net.minecraft.server.Chunk chunk) {
		this.buffer = pool.create(this);
		this.rawData = this.buffer.getData();
		System.arraycopy(chunk.b, 0, this.rawData, 0, 32768);
        System.arraycopy(chunk.g.a, 0, this.rawData, 32768, 16384);
        System.arraycopy(chunk.i.a, 0, this.rawData, 49152, 16384);
        System.arraycopy(chunk.h.a, 0, this.rawData, 65536, 16384);
        this.a = chunk.x << 4;
        this.c = chunk.z << 4;
        this.d = this.f = 16;
        this.e = 128;
	}

	public void send(EntityPlayer player) {
		this.ep = player;
		player.netServerHandler.sendPacket(this);
	}
	
	public void a(DataOutputStream dataoutputstream) throws IOException {
		boolean empty;
		try {
			empty = super.buffer == null;
		} catch (Throwable t) {
			empty = false;
		}
		if (empty) {
			if (this.ep != null) {
				//throw this packet back in the queue
				this.lowPriority = true;
				this.ep.netServerHandler.sendPacket(this);
				return;
			}
		} else {
			super.a(dataoutputstream);
		}
		this.buffer.setFree(this);
		this.buffer = null;
		this.ep = null;
	}
		
	static {
		try {
			Field a = Packet.class.getDeclaredField("a");
			a.setAccessible(true);
			Map map = (Map) a.get(null);
			map.put(BufferedPacket51MapChunk.class, 51);
		} catch (Exception e) {
			NoLagg.log(Level.SEVERE, "Failed to bind to map packet chunk, total failure imminent!");
			e.printStackTrace();
		}
	}


}
